/*
 * Copyright (c) 2016 CA.  All rights reserved.
 *
 * This software and all information contained therein is confidential
 * and proprietary and shall not be duplicated, used, disclosed or
 * disseminated in any way except as authorized by the applicable
 * license agreement, without the express written permission of CA.
 * All authorized reproductions must be marked with this language.
 *
 * EXCEPT AS SET FORTH IN THE APPLICABLE LICENSE AGREEMENT, TO THE
 * EXTENT PERMITTED BY APPLICABLE LAW, CA PROVIDES THIS SOFTWARE
 * WITHOUT WARRANTY OF ANY KIND, INCLUDING WITHOUT LIMITATION, ANY
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR
 * PURPOSE.  IN NO EVENT WILL CA BE LIABLE TO THE END USER OR ANY
 * THIRD PARTY FOR ANY LOSS OR DAMAGE, DIRECT OR INDIRECT, FROM THE
 * USE OF THIS SOFTWARE, INCLUDING WITHOUT LIMITATION, LOST PROFITS,
 * BUSINESS INTERRUPTION, GOODWILL, OR LOST DATA, EVEN IF CA IS
 * EXPRESSLY ADVISED OF SUCH LOSS OR DAMAGE.
 *
 */

package sample.restclient;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import java.io.IOException;
import java.util.Map;

/**
 * This abstract class provides methods for printing JSON data in a readable way
 */
public abstract class JSON {
  //To use custom type adapter with Gson, must register it with a GsonBuilder
    static Gson gson = new GsonBuilder()
            .registerTypeAdapter(ObjectData.class, new ObjectDataTypeAdapter())
            .create();

    static public String pp(String json) throws IOException {
        Map obj = gson.fromJson(json, Map.class);
        return pp(obj);
    }

    //use gson pretty printing to convert JSON to readable String format
    static public String pp(Object obj) throws IOException {
        Gson g = new GsonBuilder()
            .registerTypeAdapter(ObjectData.class, new ObjectDataTypeAdapter())
            .setPrettyPrinting()
            .create();

        String json = g.toJson(obj, obj.getClass());
        String result = json + "\n\n";
        return result;
    }
}
